﻿using Syncfusion.Presentation;
using Syncfusion.PresentationRenderer;
using System;
using System.Drawing;
using System.IO;

namespace SyncfusionApp
{
    internal class Program
    {

        static void Main(string[] args)
        {
            ConvertPptToImage();
        }

        public static void ConvertPptToImage()
        {
            var fileStream = GetFileStream();
            int NUMBER_OF_PAGES_TO_PROCESS = 5;

            try
            {
                using (var doc = Presentation.Open(fileStream))
                {
                    doc.PresentationRenderer = new PresentationRenderer();
                    doc.FontSettings.SubstituteFont += SubstituteFont;

                    for (var i = 0; i < doc.Slides.Count && i < NUMBER_OF_PAGES_TO_PROCESS; i++)
                    {
                        //var tables = doc.Slides[i].Tables;
                        //if (tables.Count > 0)
                        //{
                        //    continue;
                        //}
                        using (var imageStream = doc.Slides[i].ConvertToImage(ExportImageFormat.Png))
                        using (var pageImage = Image.FromStream(imageStream))
                        {
                            imageStream.Position = 0;
                        }

                    }
                }
            }
            catch (Exception exception)
            {
                Console.WriteLine(exception.Message);
                throw exception;
            }
        }


        private static void SubstituteFont(object sender, SubstituteFontEventArgs args)
            => args.AlternateFontName = args.OriginalFontName == "Arial Unicode MS"
                ? "Arial"
                : "Times New Roman";

        public static Stream GetFileStream()
        {
            string file = @"C:\Sample_with_issue.pptx";
            if (!File.Exists(file))
            {
                return null;
            }

            var content = File.OpenRead(file);

            return content;
        }
    }
}
